<template>
  <div>
    <div>
<CModal
            title="Info"
      size="sm"
      :show.sync="smallModal">
      {{ SuccessMsg }}

</CModal>


<CCardBody>
     <h5>Trace Delete History</h5>
    
    <CDataTable
      :items="items"
      :fields="fields"
      table-filter
      items-per-page-select
      :items-per-page="5"
      pagination
      hover
      striped
      border
     >
   

<!--Adding Customs buttons to each row -->
    <template #show_details="{item}" >      
      <CButton size="sm" color="dark" class="ml-1" @click="ShowDetailsModal=true; SelectMaterial(item)"> Details </CButton>
    </template>

    </CDataTable>
     
  </CCardBody>

 </div>
<div id="overlay" v-if="ShowAddModal">
<div class="modal-dialog">

<div class="modal-content">
  <div class="modal-header">

    <h5 class="modal-title">Add New Material</h5>
    <button type="button" class="close"  @click="ShowAddModal=false">
      <span aria-hidden="true">&times;</span>
    </button>
  </div>
  <div class="modal-body p-7">
<form action="#" method="POST">

<div class="form-group">
<input type="text" name="Material_Id" class="form-control form-control-lg" placeholder="Material Id" v-model="newMaterial.material_Id">
</div>

<div class="form-group">
<input type="text" name="Material_Code" class="form-control form-control-lg" placeholder="Material Code" v-model="newMaterial.material_Code">
</div>

<div class="form-group">
<input type="text" name="workCent_Id" class="form-control form-control-lg" placeholder="Work Center Id" v-model="newMaterial.workCent_Id">
</div>

<div class="form-group">
<input type="text" name="material_CreationDate" class="form-control form-control-lg" placeholder="Material Creation Date"  v-model="newMaterial.material_CreationDate">
</div>

<div class="form-group">
<input type="text" name="status" class="form-control form-control-lg" placeholder="Material status"  v-model="newMaterial.status">
</div>

<div class="form-group">
<CButton size="sm" color="info" class=""  @click="ShowAddModal=false;addMaterials();" > Add Material </CButton>
</div>

</form>
 </div>
</div>
</div>
 </div>

<!-- Show Details Modal -->
<div id="overlay" v-if="ShowDetailsModal">
<div class="modal-dialog">

<div class="modal-content">
  <div class="modal-header">
    <h5 class="modal-title">Material Details</h5>
    <button type="button" class="close"  @click="ShowDetailsModal=false">
    <span aria-hidden="true">&times;</span>
    </button>
  </div>
<div class="modal-body p-4">

<form action="#" method="POST">
<div class="form-group">
<input type="text" name="Material_Id" class="form-control form-control-lg" placeholder="Material Id" v-model="newMaterial.material_Id">
</div>

<div class="form-group">
<input type="text" name="Material_Code" class="form-control form-control-lg" placeholder="Material Code" v-model="newMaterial.material_Code">
</div>

<div class="form-group">
<input type="text" name="workCent_Id" class="form-control form-control-lg" placeholder="Work Center Id" v-model="newMaterial.workCent_Id">
</div>

<div class="form-group">
<input type="text" name="material_CreationDate" class="form-control form-control-lg" placeholder="Material Creation Date"  v-model="newMaterial.material_CreationDate">
</div>

<div class="form-group">
<input type="text" name="status" class="form-control form-control-lg" placeholder="Material status"  v-model="newMaterial.status">
</div>

<div class="form-group">
<button class="btn btn-info btn-block btn-lg"  @click="ShowDetailsModal=false;" > Close </button>
</div>
</form>

</div>
</div>
</div>
</div>

<!-- Show Update Modal -->
<div id="overlay" v-if="ShowUpdateModal">
<div class="modal-dialog">

<div class="modal-content">
  <div class="modal-header">
    <h5 class="modal-title">Update Material</h5>
    <button type="button" class="close"  @click="ShowUpdateModal=false">
    <span aria-hidden="true">&times;</span>
    </button>
  </div>
  <div class="modal-body p-4">
<form action="#" method="POST">
<div class="form-group">
<input type="text" name="Material_Id" class="form-control form-control-lg" placeholder="Material Id" v-model="newMaterial.material_Id">
</div>

<div class="form-group">
<input type="text" name="Material_Code" class="form-control form-control-lg" placeholder="Material Code" v-model="newMaterial.material_Code">
</div>

<div class="form-group">
<input type="text" name="workCent_Id" class="form-control form-control-lg" placeholder="Work Center Id" v-model="newMaterial.workCent_Id">
</div>

<div class="form-group">
<input type="text" name="material_CreationDate" class="form-control form-control-lg" placeholder="Material Creation Date"  v-model="newMaterial.material_CreationDate">
</div>

<div class="form-group">
<input type="text" name="status" class="form-control form-control-lg" placeholder="Material status"  v-model="newMaterial.status">
</div>

<div class="form-group">
<button class="btn btn-info btn-block btn-lg"  @click="ShowUpdateModal=false;UpdateMaterials();" > Update Material </button>
</div>
</form>

</div>
</div>
</div>
</div>

<!-- Delete Modal -->
<div id="overlay" v-if="ShowDeleteModal">
<div class="modal-dialog">

<div class="modal-content">
  <div class="modal-header">

    <h5 class="modal-title">Delete Material</h5>
    <button type="button" class="close"  @click="ShowDeleteModal=false">
    <span aria-hidden="true">&times;</span>
    </button>
  </div>
  <div class="modal-body p-4">
<h4 class="text-danger"> Are you sure want to delete the material ? </h4>
<h5> You are deleting {{ this.CurrentMaterial.material_Id +' || '+ this.CurrentMaterial.material_Code }}</h5>
<hr>
<button class="btn btn-danger btn-lg" @click="ShowDeleteModal=false; deleteItem();getAllMaterialDetails()  "> Yes </button>
&nbsp;&nbsp;&nbsp;&nbsp;  
<button class="btn btn-success btn-lg" @click="ShowDeleteModal=false"> No </button>
</div>
</div>
</div>
</div>
</div>
</template>

<script>
 
//import CTableWrapper from '.@/Table.vue' 
import Vue from 'vue'
import axios from 'axios'
import VUEAxios from 'vue-axios'
Vue.use(VUEAxios,axios)

export default {
   //components: { CTableWrapper },
  data ()
  {
     return {
    items: items.map((item, id) => { return {...item, id}}),
    
 
  details: [],
  collapseDuration: 0,
  errMsg:"",
  SuccessMsg:"",
  ShowAddModal:"",
  ShowDeleteModal:"",
  CurrentMaterial:"",
  ShowUpdateModal:"",
  ShowDetailsModal:"",
  smallModal: false,
  newMaterial: {material_Id:0,material_Code:"",workCent_Id:0,material_Type:"",material_CreationDate:new Date(),material_CreatedBy:"",status:1,}, }
  },
  selectOptions: [
    { 
          value: 1, 
          label: 'FLAP'
    },
    { 
          value: 2, 
          label: 'TYRE'
    }
    ],
    selectedOption: 1,

  
  mounted()
  {
   this.getAllMaterialDetails();
  },

  methods:
  {
   getAllMaterialDetails: function()
   {
  // Vue.axios.get('http://172.23.8.193:8095/api/FGS_FIFO_Material_Master')
   Vue.axios.get('https://localhost:44348/api/Trace_Material_Master')
    .then((response)=>{
    if(response.data.error)
       {
         this.errMsg=response.data.message;
       }
    else
       {
        this.items =response.data.filter(x => x.status == 1);
       // this.subitems = response.data.fgS_FIFO_Material_Type_Master;

       }
    });
   },

   
  addMaterials()
  {
    Vue.axios.post('https://localhost:44348/api/Trace_Material_Master/',this.newMaterial).then((response)=>{
       if(response.data.error)
       {
          alert('Data Error')
       }
       else
       {
        this.SuccessMsg ="Records Inserted Successfully.."
        this.getAllMaterialDetails();
       }
    })
   },

  UpdateMaterials()
  {
 Vue.axios.put('https://localhost:44348/api/Trace_Material_Master/'+this.CurrentMaterial.material_Id,this.CurrentMaterial,).then((response)=>{
       if(response.data.error)
       {
          alert('Data Error')
       }
       else
       {
         this.SuccessMsg ="Records Updated Successfully.."
         this.getAllMaterialDetails();
       }
    })
   },

  deleteItem()
    {
      var material_Id = this.CurrentMaterial.material_Id;
        axios({   method: 'delete',
           url: 'https://localhost:44348/api/Trace_Material_Master/'+ material_Id
    });
        this.SuccessMsg="Material Status Changed to Inactive Succesfully"
    },
      
  SelectMaterial(Material)
    {
     this.CurrentMaterial=Material;
    },
    
  toFormData(obj)
    {
     var fd=new FormData();
     for(var i in obj)
     {
       fd.append(i,obj[i]);
       alert(i+'#'+ obj[i])
     }
     return fd;
   },
  
  
  
   
   toggleDetails (item) {
      this.$set(this.items[item.material_Id-1], '_toggled', !item._toggled)
      this.collapseDuration = 300
      this.$nextTick(() => { this.collapseDuration = 0})
    },
    getShuffledUsersData (){
 
   Vue.axios.get('https://localhost:44348/api/Trace_Material_Master')
    .then((response)=>{
    if(response.data.error)
       {
         this.errMsg=response.data.message;
       }
    else
       {
        this.items =response.data.filter(x => x.status == 1)
       }
    });
   },
    
    },
  
    

}
</script>

<style scoped>
#overlay{
  position:fixed;
  top:100px;
  bottom:0;
  left:0;
  right:0;
  background:rgba(0,0,0,0.6);
}
</style>